PrintWriter output;
XMLElement graf;
String lines[];
String grafFile="timothy.graf";
String gmlFile;

void convertGraf()
{
  int startLine=0;
  String[] p;
  output.println("<GML spec=\"0.1b\">");
  output.println("  <tag>");
  output.println("    <header>");
  output.println("      <client>");
  output.println("        <name>Name here</name>");
  output.println("        <version>Version here</version>");
  output.println("        <username>Username here</username>");
  output.println("        <keywords>Keywords, here</keywords>");
  output.println("        <uniqueKey>Unique here</uniqueKey>");
  output.println("      </client>");
  output.println("    </header>");
  output.println("    <drawing>");
  lines=loadStrings(grafFile);
  do
  {
    p=splitTokens(trim(lines[startLine]),"<>");
    startLine++;
  }
  while(match(p[0],"recording")==null && startLine<lines.length);
  startLine--;
  for (int i=startLine;i<lines.length;i++)
  {
    print(".");
    p = splitTokens(trim(lines[i]),"<>");
    if(match(p[0],"recording")!=null && match(p[0],"/")==null) output.println("      <stroke>");
    if(match(p[0],"/recording")!=null) output.println("      </stroke>");
    if(match(p[0],"pt")!=null && match(p[0],"/")==null) output.println("        <pt>");
    if(match(p[0],"/pt")!=null) output.println("        </pt>");
    if(match(p[0],"x")!=null && match(p[0],"/")==null) output.println("          <x>"+p[1]+"</x>");
    if(match(p[0],"time")!=null && match(p[0],"/")==null) output.println("          <time>"+p[1]+"</time>");
    if(match(p[0],"y")!=null && match(p[0],"/")==null)
    {
      output.println("          <y>"+p[1]+"</y>");
      output.println("          <z>0</z>");
    }
  }
  output.println("    </drawing>");
  output.println("  </tag>");
  output.println("</GML>");
}

void setup()
{
  size(512,200,P2D);
  gmlFile=grafFile+".gml";
  output=createWriter(gmlFile);
  print("Converting "+grafFile+" to "+gmlFile+" ");
  convertGraf();
  println();
  println("Conversion finished!");
  output.flush();
  output.close();
  exit();
}

void draw()
{
}


